; HoleX
; https://rmda.su
; 11.10.2024

; Some tech details:

; 5928b is maximum for UPKR data to be linked in 6912 bytes
; #1900 CALL's in first full screen noise part (HOLE17)
; #2c00 CALL's in last FX (credits)

; 28009 bytes input of mixed binary
; 5907  bytes output after UPKR
; UPKR (fast), 1119 T per byte, 8 sec. to unpack
; UPKR (normal), 1324 T per byte, 10 sec. to unpack

; https://github.com/z00m128/sjasmplus/releases/
; https://github.com/exoticorn/upkr
; https://github.com/vasilenkoroman/psg_compressor
; https://gist.github.com/raxoft/2275716fea577b48f7f0
; https://gist.github.com/raxoft/c074743ea3f926db0037
; https://damieng.com/typography/zx-origins/
; https://debutart.com/artist/laurie-greasley/alien-friend-weyland-yutani-corp

	DEVICE	ZXSPECTRUM48

	ORG	#5800
	INCBIN	"cat.atr"

PTS_NUM	equ	#90
ST_ADD1	equ	#7f
ST_ADD2	equ	#fd
SCL_ST	equ	#0200
SCL_ADD	equ	#0020
ST_MAX	equ	#ff00

SMULSIZE equ	#20

;	define __RNDSTARS

_DATA   EQU     #5b00
SCR_TBL EQU     _DATA
BUFFER1 EQU     SCR_TBL+#0200
SMULTBL	EQU     BUFFER1+#0200
pts_cls EQU     SMULSIZE*#0100+SMULTBL
pts_out EQU     PTS_NUM*5+1+pts_cls

;delays
pause:	EQU	#19			;delay after each slide
sync1:	EQU	#0500+1620+260-900-100	;HOLE17 start
sync2:	EQU	#0a23+1420-400-200	;HOLE17 exit
sync3:	EQU	#0b5c+1420-220-128+30	;HOLE23 start
sync4:	EQU	#18a0+1420-220-125	;HOLE11 start
sync11:	EQU	#22a0-140		;HOLE11 exit
sync5:	EQU	#2700+70		;part 4 start
syncend:EQU	#2e00			;end of music
end23:	EQU	#1780			;HOLE23 exit
;	part2delay
;	part4fix

;---------------------------------------------------------------

	org	#9200
begin:
	ld	sp,0
	ld	a,#fe
	ld	i,a
	im	2		

	ld	hl,im2ret
	ld	(#fdfe),hl

	jp 	skipstar

;-------RMDA star-----------------------------------------------
star:
	ld	hl,#5800
chess:  dec	hl	
	ld	a,h
	rra
        sbc	a,a
        xor	%01010101
        ld	(hl),a
	cp	(hl)
	jr	z,chess
;---------------------------------------------------------------
	ld	ixh,180
	ld	(starsv+1),sp
star1:
	ld	sp,#5b00

	ei
	halt

starf:	ld	a,0
	out	(#fe),a

stara:	ld	hl,#0000
	push	hl
	pop	af

starh:	ld	hl,#7900
stard:	ld	de,#7979
starb:	ld	bc,#0079

	defb	#C5,#E5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#C5,#E5
	defb	#F5,#D5,#E5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#C5,#D5,#F5
	defb	#F5,#C5,#D5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#D5,#E5,#F5
	defb	#F5,#F5,#D5,#E5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#C5,#D5,#F5,#F5
	defb	#F5,#F5,#C5,#D5,#F5,#F5,#D5,#D5,#D5,#D5,#F5,#F5,#D5,#E5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#F5,#D5,#F5,#F5,#F5,#F5,#D5,#F5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#C5,#F5,#F5,#F5,#F5,#F5,#F5,#E5,#F5,#F5,#F5,#F5
	defb	#F5,#f5,#F5,#F5,#e5,#C5,#D5,#D5,#D5,#D5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#E5,#C5,#F5,#F5,#F5,#F5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#E5,#C5,#C5,#D5,#D5,#E5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#E5,#C5,#C5,#D5,#D5,#E5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#E5,#C5,#F5,#D5,#D5,#F5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#E5,#C5,#F5,#C5,#E5,#F5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#E5,#C5,#F5,#F5,#F5,#F5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#E5,#C5,#D5,#D5,#D5,#D5,#E5,#C5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#C5,#F5,#F5,#F5,#F5,#F5,#F5,#E5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#C5,#D5,#F5,#D5,#F5,#F5,#F5,#F5,#D5,#F5,#D5,#E5,#F5,#F5
	defb	#F5,#D5,#D5,#D5,#F5,#F5,#D5,#D5,#D5,#D5,#F5,#F5,#D5,#D5,#D5,#F5
	defb	#D5,#D5,#D5,#D5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#D5,#D5,#D5,#D5
	defb	#F5,#F5,#F5,#F5,#F5,#F5,#D5,#D5,#D5,#D5,#F5,#F5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#F5,#F5,#C5,#D5,#D5,#E5,#F5,#F5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#F5,#F5,#F5,#D5,#D5,#F5,#F5,#F5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#F5,#F5,#F5,#C5,#E5,#F5,#F5,#F5,#F5,#F5,#F5,#F5
	defb	#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5,#F5

	ld	a,(starf+1)
	xor	1
	ld	(starf+1),a
;----
;!!AF
	ld	a,(stara+1)
	xor	9
	ld	h,a
	ld	l,a
	ld	(stara+1),hl
;----
;!!HL
	ld	(starh+1),a
;----
;!!BC
	ld	(starb+2),a
;----
	dec	ixh
	jp	nz,star1

starsv:	ld	sp,#c9c9
	ret
;---------------------------------------------------------------

;!! SERZh fader

skipstar:

	ld	hl,SIN_TBL
	ld	bc,#0001
lp_sfd0:
	ld	a,l
	and	#07
	sub	c
	adc	a,b
	ld	e,a
	ld	a,l
	rra
	rra
	rra
	and	#07
	sub	c
	adc	a,b
	add	a,a
	add	a,a
	add	a,a
	add	a,e
	ld	(hl),a
	inc	l
	jr	nz,lp_sfd0

	ld	b,#38

lp_sfd1:
	push	bc
	ei
	halt

;some scr fader for Irreality :) (c)SerzhSoft
	ld	bc,#fff3
	ld	hl,#f6ff
hl_fade equ $-2
	ld	a,l
	dec	l
	cp	c
	jr	nc,$+3
	ld	l,b
	rrc	h
	ld	(hl_fade),hl

	ld	d,h
	ld	h,#57

lp_fade:
; dup N	;some N for best speed
	ld	a,d
	and	(hl)
	ld	(hl),a
	add	hl,bc
; edup

	bit	6,h
	jp	nz,lp_fade

;/fader

	pop	bc
	djnz	lp_sfd1

	ld	b,#08

lp_sfd2:
	push	bc
	ei
	halt
	halt

	ld	a,b
	dec	a
	out	(#fe),a

	ld	hl,SIN_TBL
	ld	de,#5800
	ld	bc,#0300

lp_sfd3:
	ld	a,(de)
	ld	l,a
	ldi
	jp	pe,lp_sfd3

	pop	bc
	djnz	lp_sfd2

;---------------------------------------------------------------

SINSPD equ #0010

 ld hl,#7fff
 ld de,#fc1d
 ld bc,SIN_TBL

lpsinmk:
 xor a
 sub h
 ld (bc),a
 cpl

 cp #7e ;#7f
 ld sp,SINSPD
 jr c,$+5
 ld sp,-SINSPD

 ex de,hl
 add hl,sp
 ex de,hl
 add hl,de

 inc c
 jr nz,lpsinmk
;---------------------------------------------------------------

	call	totalcls

	call	init		;AY track init
	ld	hl,im2ay
	ld	(#fdfe),hl      ;set JP to IM2 handler

;---------------------------------------------------------------
	ld	b,#50
	call	delay+2

	call	star

	call	totalcls

	ld	b,#30
	call	delay+2

	call	nanohl

	call	totalcls

	call	delay

	call	slide

	ld	b,#73
	call	delay+2

free:	;all memory before this will be cleared

	call	h17init		;HOLE 17 init sequence

	call	delay
	
	jp	holex

;!!-------PART 2 HOLE 23----------------------------------------
part2:	
	ld	sp,0
	ld	hl,im2ay
	ld	(#fdfe),hl      ;set JP to IM2 handler

;-------all pRNG data generated, now generate main loop code----
	ld	de,#ff08
	ld	a,d
;--------RL+PUSH code generator---------------------------------
;ld a,(hl)
;inc hl
;dec ixh
;rla
;....
;rl (ix+x),d	;23T
;rl (ix+x),e	;23T
;push de	;11T    =57T per 4 bytes, 14,25T per byte
;....
;LOOP
	ld	hl,gento	;where to generate Z80 code

	rra			;A=#7F, initial state for IX+X

	ld	d,e             ;D=8, number of segments 32x8
gen1:	
 	ld	b,e             ;B=8, number of lines in segment
;---------------------------------------------------------------
	ld	(hl),#7E        ;LD A,(HL)	;7T
	inc	hl
	ld	(hl),#23	;INC HL		;6T
	inc	hl	
;---------------------------------------------------------------
	ld	(hl),#DD
	inc	hl
	ld	(hl),#25	;DEC IXH	;8T
	inc	hl
;-------one pixel line------------------------------------------
gen2:	ld	c,#10		;32 byte per line / 2
;-------4T bit extractor----------------------------------------
	ld	(hl),#17        ;RLA		;4T
	inc	hl		
;-------two bytes RL--------------------------------------------
gen3:	ld	(hl),#DD
	inc	hl
	ld	(hl),#CB
	inc	hl
	ld	(hl),a          ;+X
	dec	a
	inc	hl
	ld	(hl),#12	;RL (IX+N),D	;23T

	inc	hl

	ld	(hl),#DD
	inc	hl
	ld	(hl),#CB
	inc	hl
	ld	(hl),a          ;+X
	dec	a
	inc	hl
	ld	(hl),#13	;RL (IX+N),E	;23T 

	inc	hl
;-------two bytes PUSH------------------------------------------
	ld	(hl),#d5	;PUSH DE	;11T
	inc	hl
	dec	c
	jr	nz,gen3
;-------end of 1 line-------------------------------------------
	djnz	gen2
;---------------------------------------------------------------
	dec	d
	jr	nz,gen1
;-------end of code generation----------------------------------

;-------FX loop init--------------------------------------------
	xor	a
	call	attrcls
	dec	a
	call	pixcls
;---------------------------------------------------------------
	ld	h,#5c
	ld	de,#4800
	ld	bc,2048
	ldir

	ld	a,%01000101	;color of scrolling noise area
	call	attrcls

;!!-------HOLE 23 banner----------------------------------------
btsprt:	EQU	#4860+14

	ld	hl,#FFFF
	ld	(btsprt),hl
	ld	(btsprt+2),hl	
	ld	(btsprt+#700),hl
	ld	(btsprt+#700+2),hl

	ld	hl,#2FB4
	ld	(btsprt+#100),hl

	ld	h,#21
	ld	(btsprt+#600),hl

	ld	hl,#110F
	ld	(btsprt+#100+2),hl
	ld	(btsprt+#300+2),hl
	ld	(btsprt+#600+2),hl

	ld	hl,#AFB5
	ld	(btsprt+#200),hl
	ld	(btsprt+#400),hl
	ld	(btsprt+#500),hl

	ld	l,#85
	ld	(btsprt+#300),hl

	ld	hl,#DD7F
	ld	(btsprt+#200+2),hl

	ld	h,#7D
	ld	(btsprt+#400+2),hl
	ld	(btsprt+#500+2),hl

;---------------------------------------------------------------
	ld	b,%00110110	;set color of hole background
	ld	hl,im2h23
	ld	(#fdfe),hl      ;set JP to IM2 handler

;!!! part 2 sprite
	ld	hl,#5b00	;start of sprite

;-------HOLE 23 main FX loop------------------------------------

h23spr:	EQU #64a0	;!!!end of sprite for HOLE #23 (lenght of FX)
			;usefull for lenght fix
im2h23:
	ld	c,b	;duplicate hole background color

	ld	sp,#5a00
	push	bc,bc,bc,bc,bc,de,de,de,de,de,de,bc,bc,bc,bc,bc
	push	bc,bc,bc,bc,de,de,de,de,de,de,de,de,bc,bc,bc,bc
	push	bc,bc,bc,de,de,de,de,de,de,de,de,de,de,bc,bc,bc
	push	bc,bc,de,de,de,de,de,de,de,de,de,de,de,de,bc,bc
	push	bc,bc,de,de,de,de,de,de,de,de,de,de,de,de,bc,bc
	push	bc,bc,bc,de,de,de,de,de,de,de,de,de,de,bc,bc,bc
	push	bc,bc,bc,bc,de,de,de,de,de,de,de,de,bc,bc,bc,bc
	push	bc,bc,bc,bc,bc,de,de,de,de,de,de,bc,bc,bc,bc,bc

	ld	a,d            ;swap hole color for up & down
	ld	d,e
	ld	e,a

	ld	sp,#58f3
	push	de,de,de
	ld	sp,#5a13
	push	de,de,de

	ld	de,#4747
	ld	sp,#5972	;HOLE banner color update
	push	de
	push	de

;---------------------------------------------------------------
	ld	ix,#4880  ;middle of last 256 byte segment to RL
	ld	sp,#5800  ;end of area to PUSH
;---------------------------------------------------------------
gento:
	DUP	9312
	defb	#00
	EDUP
rnd17:
;-------HOLE 23 end sequence------------------------------------
;a=current pRNG byte
;bc=#2d2d solid color
;de=current pRNG data
;hl=current adress of pRNG data
;---------------------------------------------------------------

	and	%00010000
	xor	c
	and	%00000111
	out	(#fe),a

;-------HL check------------------------------------------------
	ld	a,h
part2delay:
	cp	#64		;high h23spr
	jr	c,exit

	ld	a,b
	sub	9
;	jp	c,ret23

scol:	ld	b,a
	ld	h,#5b		;start of sprite
;-------end of frame--------------------------------------------
;SP=#5000
exit:	
	push	hl
	push	bc
	push	de

	call	play
	ld	hl,(frames)
	inc	hl
	ld	(frames),hl
			
	ld	de,end23
	or	a
	sbc	hl,de
	add	hl,de
	jp	z,ret23

	ld	bc,#7ffe
	in	a,(c)
	rrca
	jr	nc,$-3		;SPACE to solve enigma

	pop	de
	pop	bc
	pop	hl

	ei
	halt

;!!!	PART 4: NEW HOLE                                

;1 byte of sprite per 4 charlines
;2 bytes per one third
;6 bytes per one row of screen

;example of chessboard pattern for HoleX fx
;	DUP	200
;	DUP	4
;	defb	%01010101
;	defb	%01010101
;	defb	%01010101
;	defb	%01010101
;	defb	%01010101
;	defb	%01010101
;	EDUP
;	DUP	4
;	defb	%10101010
;	defb	%10101010
;	defb	%10101010
;	defb	%10101010
;	defb	%10101010
;	defb	%10101010
;	EDUP
;	EDUP

sprite:	EQU	#5b00

part4:
;---------------------------------------------------------------
	ld	a,%01000110
	call	attr
;-------draw purple frame-----------------------------
	ld	hl,#1b1b

;--up left---
	ld	(#5800),hl
	ld	(#5820),hl
	ld	(#5840),hl
	ld	(#5860),hl
	ld	(#5880),hl
	ld	(#58a0),hl
	ld	(#58c0),hl
	ld	(#58e0),hl

	call	delay

;--down right---
	ld	(#5a00+#1e),hl
	ld	(#5a20+#1e),hl
	ld	(#5a40+#1e),hl
	ld	(#5a60+#1e),hl
	ld	(#5a80+#1e),hl
	ld	(#5aa0+#1e),hl
	ld	(#5ac0+#1e),hl
	ld	(#5ae0+#1e),hl

	call	delay

;--down left---
	ld	(#5a00),hl
	ld	(#5a20),hl
	ld	(#5a40),hl
	ld	(#5a60),hl
	ld	(#5a80),hl
	ld	(#5aa0),hl
	ld	(#5ac0),hl
	ld	(#5ae0),hl

	call	delay

;--up right---

	ld	(#5800+#1e),hl
	ld	(#5820+#1e),hl
	ld	(#5840+#1e),hl
	ld	(#5860+#1e),hl
	ld	(#5880+#1e),hl
	ld	(#58a0+#1e),hl
	ld	(#58c0+#1e),hl
	ld	(#58e0+#1e),hl

	call	delay

;--left right------------------
	ld	(#5900-1),hl
	ld	(#5920-1),hl
	ld	(#5940-1),hl
	ld	(#5960-1),hl
	ld	(#5980-1),hl
	ld	(#59a0-1),hl
	ld	(#59c0-1),hl
	ld	(#59e0-1),hl
	ld	(#59e0+#1f),hl
;------------------------------

;	call	delay

        ld	h,#6f
	call	rndfill
;---sprite patch--------------------------
	ld	hl,#5b00
	xor	a
	ld	b,8
patch1:
	inc	l
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	djnz	patch1

;!!!-----border fill--------------------
border:
	halt
	ld	a,3
	out	(#fe),a

	ld	h,#00
	ld	d,h

del:	ld	bc,30
	ldir
	
	xor	a
	out	(#fe),a

	ld	hl,(del+1)
	ld	bc,30
	add	hl,bc
	ld	(del+1),hl

	ld	a,(del+2)
	cp	13

	jr	nz,border

;---------------------------------------------------------------
	ld	a,3
	out	(#fe),a
	halt

;!!!---NEW HOLE----------------------------------------
	ld	iy,sprite

	ld	hl,mainfx	;set JP to IM2 handler
	ld	(#fdfe),hl
rep:
	ld	sp,0
	ei
	halt

at = 2	;global screen shift

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!! 2 third
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;-------scroll----------------------------------------
ixing = #4b20 - at + 1
stack = ixing - #300

;---one third of screen-------------------------------
	DUP	2
;----next sprite byte---------------------------------
	ld	a,(iy+0)
	inc	iy
;----half of one third--------------------------------
	DUP	4
;----one screen char line-----------------------------
; first half of charline
;----extract 1 bit from sprite------------------------
	rla
shift = -1
	ld	ix,ixing
;-------ROLL first 12 bytes---------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH first 12 bytes-----------------------------
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
;-------ROLL second 12 bytes----------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH second 12 bytes----------------------------
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #200 - 12
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
;-------ROLL and PUSH last 4 bytes----------------------1
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2

	push	de,hl,bc

stack = stack + #200 - 12

	ld	sp,stack
	push	de,hl,bc
	ld	sp,stack+#100
	push	de,hl,bc

	inc	ixh
stack = ixing + #200

;second half of charline

;----extract 1 bit from sprite------------------------
	rla
shift = -1
;-------ROLL first 12 bytes---------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH first 12 bytes-----------------------------
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
;-------ROLL second 12 bytes----------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH second 12 bytes----------------------------
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #200 - 12
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
;-------ROLL and PUSH last 4 bytes----------------------
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	push	de,hl,bc

stack = stack + #200 - 12

	ld	sp,stack
	push	de,hl,bc
	ld	sp,stack+#100
	push	de,hl,bc

;end of one charline
ixing = ixing + #20
stack = ixing - #300

	EDUP

;-----end of one third of screen----------
	EDUP
;-----end of three thirds of screen-------

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!! 3 third
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;-------scroll----------------------------------------
ixing = #5320 - at
stack = ixing - #300

;---one third of screen-------------------------------
	DUP	2
;----next sprite byte---------------------------------
	ld	a,(iy+0)
	inc	iy
;----half of one third--------------------------------
	DUP	4
;----one screen char line-----------------------------
;first half of charline
;----extract 1 bit from sprite------------------------
	rla
shift = -1
	ld	ix,ixing
;-------ROLL first 12 bytes---------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH first 12 bytes-----------------------------
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
;-------ROLL second 12 bytes----------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH second 12 bytes----------------------------
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #200 - 12
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
;-------ROLL and PUSH last 4 bytes----------------------
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2

	push	de,hl

stack = stack + #200 - 12

	ld	sp,stack
	push	de,hl
	ld	sp,stack+#100
	push	de,hl

	inc	ixh
stack = ixing + #200

;!!! second half of charline<<<

;----extract 1 bit from sprite------------------------
	rla
shift = -1
;-------ROLL first 12 bytes---------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH first 12 bytes-----------------------------
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
;-------ROLL second 12 bytes----------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH second 12 bytes----------------------------
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #200 - 12
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
;-------ROLL and PUSH last 4 bytes----------------------
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	push	de,hl

stack = stack + #200 - 12

	ld	sp,stack
	push	de,hl
	ld	sp,stack+#100
	push	de,hl

;end of one charline
ixing = ixing + #20
stack = ixing - #300

	EDUP

;-----end of one third of screen----------
	EDUP
;-----end of three thirds of screen-------

;-----AY music for NEW HOLE----------------------------
	ld	a,r
	and	%00000111
	out	(#fe),a
	ld	sp,0
	call	play

	ld	hl,(frames)
	inc	hl
	ld	(frames),hl

	ld	a,3
	out	(#fe),a

;!! part4fix
	ld	a,iyh
	cp	#6f	;end of NEW HOLE sprite
	jr	nz,skip

;!!exit from NEW HOLE

;	ld	iyh,#5c	;if we need loop sprite
	jp	retnew
skip:

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!! copy of code above for one third to override the beam 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;-------scroll----------------------------------------
ixing = #4320 - at
stack = ixing - #300
;---one third of screen-------------------------------
	DUP	2
;----next sprite byte---------------------------------
	ld	a,(iy+0)
	inc	iy
;----half of one third--------------------------------
	DUP	4
;----one screen char line-----------------------------
;!!! first half of charline
;----extract 1 bit from sprite------------------------
	rla
shift = -1
	ld	ix,ixing
;-------ROLL first 12 bytes---------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH first 12 bytes-----------------------------
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
;-------ROLL second 12 bytes----------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH second 12 bytes----------------------------
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #200 - 12
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
;-------ROLL and PUSH last 4 bytes----------------------
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2

	push	de,hl

stack = stack + #200 - 12

	ld	sp,stack
	push	de,hl
	ld	sp,stack+#100
	push	de,hl

	inc	ixh
stack = ixing + #200

;!!! second half of charline                          

;----extract 1 bit from sprite------------------------
	rla
shift = -1
;-------ROLL first 12 bytes---------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH first 12 bytes-----------------------------
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack + #100
;-------ROLL second 12 bytes----------------------------
	DUP	2
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2
	rl	(ix+shift),b :	rl	(ix+shift-1),c
shift = shift - 2
	exx
	EDUP
	ORG	$-1	;remove last EXX
;-------PUSH second 12 bytes----------------------------
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #200 - 12
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
	ld	sp,stack
	exx	: push	de,hl,bc : exx : push	de,hl,bc
stack = stack - #100
;-------ROLL and PUSH last 4 bytes----------------------
	rl	(ix+shift),d :	rl	(ix+shift-1),e
shift = shift - 2
	rl	(ix+shift),h :	rl	(ix+shift-1),l
shift = shift - 2

	push	de,hl

stack = stack + #200 - 12

	ld	sp,stack
	push	de,hl
	ld	sp,stack+#100
	push	de,hl

;---------------------------------------------------------------

;!!!end of one charline
ixing = ixing + #20
stack = ixing - #300

	EDUP

;-----end of one third of screen----------
	EDUP
;-----end of three thirds of screen-------

;	ld	a,6
;	out	(#fe),a

;----end of one third---------------------

;	ld	a,1
;	out	(#fe),a

;-----end of screen ----------------------
	jp	rep

;---------------------------------------------------------------
holex:
	xor	a
	call	pixcls

	ld	a,105q
	call	attr

	ld	de,#0900	;D=Y, E=X
	ld	hl,text2
	call	string

 ifdef __RNDSTARS
  call rnd_stars
 endif

 ld de,sync1
 call wait_to_de

	jp	part1

;-------comeback from HOLE 17-------------------------
ret17:
	ld	sp,0
	ld	hl,im2ay
	ld	(#fdfe),hl      ;set JP to IM2 handler

	call	totalcls

;slide3: ;NO ONE CAN READ OUR SCROLL
	ld	a,106q
	call	attr

	ld	de,#0900	;D=Y, E=X
	ld	hl,text3
	call	string

;!!     Serzh                                         

 call inistar

	ld	de,#0900	;D=Y, E=X
	ld	hl,text3

 call printer_with_stars

 ld de,sync3
 call starloop_to_de

; call scrcls_0


;/slide3

	call	totalcls

	ld	h,#64
	call	rndfill		;!! visuals for PART2

	jp	part2

;-------comeback from HOLE 23-------------------------
ret23:
	ld	sp,0
	ld	hl,im2ay
	ld	(#fdfe),hl      ;set JP to IM2 handler

	call	totalcls

	call	slide4

	jp	part3

;-------comeback from HOLE 11-------------------------
ret11:
	ld	sp,0
	ld	hl,im2ay
	ld	(#fdfe),hl      ;set JP to IM2 handler

	call	totalcls

	call	slide5
	call	delay

;slide5: ;NOW WITH UV SCOPE

 call inistar

 ld a,#cd
 ld (atrstar),a

	ld	de,#0900	;D=Y, E=X
	ld	hl,text5

 call printer_with_stars

 ld de,sync5
 call starloop_to_de_atr

;/slide5

; call scrcls_0
	call	totalcls

	jp	part4

;---------------------------------------------------------------
slide:  ;SPACE
	ld	a,107q
	call	attr
;-------print sequence--------------------
;!!	ld	a,#1f		;RRA patch
;!!	ld	(patch),a

	ld	de,#0900	;D=Y, E=X
	ld	hl,text
	call	string
	ret

slide4:	;BUT TINY 8B
	ld	a,102q
	call	attr

	ld	de,#0900	;D=Y, E=X
	ld	hl,text4
	call	string

;-------additional attrs for assembler code------------
	ld	hl,#5960
	ld	de,#5961
	ld	bc,32*7-1
	ld	(hl),2
	ldir

;	ld	hl,102q * #101
;	ld	(#59e8),hl
;	ld	(#59e8+2),hl
;	ld	(#59e8+4),hl
;	ld	(#59e8+4),hl
;	ld	(#59e8+6),hl
	ld	a,102q
	ld	hl,#59e8
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l
	ld	(hl),a
	inc	l

;---------------------------------------------------------------
	ld	hl,#3c00
	ld	(fpatch+1),hl

	ld	de,#0c00	;D=Y, E=X
	ld	hl,text41
	call	string

	ld	hl,font-#100
	ld	(fpatch+1),hl

 ld de,sync4
 call wait_to_de

	ret

slide5:
	ld	a,105q
	call	attr

	ld	de,#0900	;D=Y, E=X
	ld	hl,text5
	call	string

	ret

slide7:
	ld	a,04q
	call	attr

	ld	de,#0900	;D=Y, E=X
	ld	hl,text7
	call	string

	ret

;-------print text string, HL=text DE=YX-----------------------
string:
	ld	a,(hl)
	or	a
	ret	z	;check EoF
	inc	hl

	push	hl
	push	de	
	call	prnchar	;print one char

	halt
	halt
;---------------------------------------------------------------
	pop	de
	pop	hl

	inc	e

	bit	5,e	;CP E=#20
	jr	z,nextchr

	inc	d	;next line
	ld	e,b	;E=0
nextchr:
	jr	string
;---------------------------------------------------------------
prnchar:

;-------get char addres on font-----------
        ld	h,0
        ld	l,a
        add	hl,hl
        add	hl,hl
        add	hl,hl
fpatch:	ld	bc,font-#100
        add	hl,bc

;-----------------------------------------
; D = Y character position (0-23)
; E = X character position (0-31)
; returns screen address in DE
charadr:
	ld	a,d
	and	#07	;%00000111
	rrca
	rrca
	rrca
	or	e
	ld	e,a
	ld	a,d
	and	#18	;%00011000
	or	#40	;%01000000
	ld	d,a	
;---------------------------------------------------------------
	ld	b,8
onechar:
	ld	a,(hl)
patch:	nop		;rra (for bold font)
	or	(hl)
	ld	(de),a
	inc	l
	inc	d
	djnz    onechar
	ret

;!!!---texts-------------------------------------
text:	
	defm	"    In SPACE no one can hear    "
	defm	"    your CALL..."
	defb	0
text2:	
	defm	"  For decades we try to master  "
	defm	"      HOLE enigma phenomena"
	defb	0
text3:	
	defm	"  We think that in space no one " 
	defm	"     can read our scroll..."
	defb	0
text4:	
	defm	"  But tiny intergalaxy probe 8b "
	defm	"    come back with response:" 
	defb	0

text41:
	defm	"      ; ld    de,4*21           "
	defm	"      ; ld    l,e               "
	defm	"      ; add   hl,de             "
	defm	"      ; inc   (hl)              "
	defm	"      ; jr    $-2"
	defb	0
text5:	
	defm	"  Now with UV orbital telescope "
	defm	"       we are step closer..."
	defb	0

text6:	
	defm	"          =RMDA=  2024          "
	defm	"                                "
	defm	"      .redefine the future"
	defb	0

text7:	defm	"HOLE enigma remains unsolved ..."
       	defm	"                                "
	defm    "          but we dare!"
	defb	0

;!!	PART 1: HOLE 17                                         

; generated	#5b00 - #ffff, any memory filled with 00,00,00

start_mem:	equ	#5b00	;start address of generated CALL
start_scr:	equ	#5800   ;end of refreshing screen area
fx_shift:	equ	24	;only even number, 2=shift 0
				;4=shift 2 bytes, 6=shift 4
				;34=scroll 34-2=32 bytes
				;and so on...

complexity:	equ	#19	;total number of CALL's
color:		equ	#30

h17init:
;-------memory and screen init----------------------------------
	ld	hl,free

	push	hl
clear:	ld	(hl),0
	dec	hl
	ld	a,h
	cp	#5a
	jr	nz,clear
;---------------------------------------------------------------
	pop	hl

	ld	bc,1		;counter of generated calls
	ld	ix,#0000	;counter of full loops

;---------------------------------------------------------------
				;HL - current address for CALL
				;DE - destination for CALL
				;BC - counter generated of CALLs
newrnd:
	ld	(hl),#cd	;new address, lets put #CD/CALL
	inc	hl		; 
;!!! very important to secure 2 next bytes (or 1 for sizecoding)
;	ld	(hl),h		;and secure 2 more bytes
	inc	hl              ;with anything, but not #00
	ld	(hl),h          ;coz #00 is the mark of free RAM
	dec	hl		;for CALL generator
;---------------------------------------------------------------
rernd:
	call	prnd		;get pRNG for high byte of DE

h17fix:	ld	(#5aff),a       ;decrunch attr update

	cp	#5b		;must be more than #5a
	jp	c,rernd		;
	
	cp	high rnd17+1	;!! both music and font contains ZEROs so we need to check high mem
	jp	nc,rernd

next:	
	ld	d,a		;store pRNG high byte in D
;---------------------------------------------------------------
	call	prnd		;get pRNG for low byte
h17fix2:
	ld	(#5aff),a       ;decrunch attr update

	ld	e,a		;any pRNG is valid so store it E
;---------------------------------------------------------------
;in HL adress of LOW byte for new CALL
;in DE destination adress of new CALL
	ld	a,(de)          
	or	a               ;check is there 0 in RAM for #CD
	jp	nz,rernd	;if not 0 then redo pRNG
;---------------------------------------------------------------
	inc	de
	ld	a,(de)
	or	a
	jp	nz,rernd	;is there 0 in RAM for low byte?
;---------------------------------------------------------------
	inc	de
	ld	a,(de)		
	or	a
	jp	nz,rernd        ;is there 0 for high byte?
;---------------------------------------------------------------
	dec	de
	dec	de

	ld	(hl),e		;put argument (new PC address) 
	inc	hl		;for #CD, chosen in nextrnd.
	ld	(hl),d       

	ld	h,d		;set this new adress as next 
	ld	l,e		;VALID address for #CD or any 
				;other 1-2-3 bytes oppcode.
			
	inc	bc

	ld	a,b

	cp	complexity	;check amount of generated data
	jp	nz,newrnd
;---------------------------------------------------------------
	ld	de,looper	;patch for end sequence of CALL's
	ld	(hl),#c3	;put JP at the end
	inc	hl		;to loop generated data.
	ld	(hl),e
	inc	hl          
	ld	(hl),d		;generated code is looped now.
;---------------------------------------------------------------
	xor	a
	ld	(#5aff),a       ;decrunch attr restore
	ret

part1:
	ld	a,66q
	call	attrcls

	ld	hl,im2h17	;set JP to IM2 handler
	ld	(#fdfe),hl
	ld	hl,free		;#START of CALL sequence

;-------HOLE 17 first run + end part of IM2 handler-------------
im2exit:
	ei
spoint:	ld	sp,start_scr
	jp	(hl)

looper:
	out	(#fe),a
	inc	ix

	ld	a,6
	out	(#fe),a

	jp	free	;BEGIN is the first CALL for loop
;---------------------------------------------------------------
im2h17:
	ld	a,6
	out	(#fe),a

	ld	sp,0
;	call	prnd
;	ld	l,a
				
;-------ATTR swap-----------------------------------------------
swap:	ld	a,color
	ld	h,#58		;L is random from last IM2

	DUP	3
	ld	(hl),a
	rlc	l
;---------------------------------------------------------------
	ld	(hl),a
	rlc	l
;---------------------------------------------------------------
	ld	(hl),a
	rlc	l
;---------------------------------------------------------------
;	inc	l
	dec	l
	ld	(hl),a

	inc 	h			
	EDUP

	xor	#36
	ld	(swap+1),a
;---------------------------------------------------------------
	call	play

	ld	hl,(frames)
	inc	hl
	ld	(frames),hl

	ld	de,sync2
	or	a
	sbc	hl,de
	add	hl,de
	jp	z,ret17

;-------keyboard------------------------------------------------
enigma:	
	ld	hl,color * #101
       	ld	(ramka),hl
	ld	(ramka+2),hl

	ld	bc,#7ffe
	in	a,(c)
	rrca
	jr	nc,enigma	;SPACE to solve enigma.

;-------mistery hole: left half---------------------------------
	ld	de,%0000001100001111
	ld	hl,#40ef	;L value used in OR action
	ld	a,(hl)
	or	d
	ld	(hl),a
	inc	h
	ld	a,(hl)
	or	e
	ld	(hl),a
	inc	h
	ld	a,(hl)          
	or	%00011111
	ld	(hl),a
	inc	h
	or	b
	ld	(hl),a
	inc	h
	ld 	(hl),a
	inc 	h
	ld	a,(hl)          
	or	%00011111		
	ld	(hl),a
	inc	h
	ld	a,(hl)
	or	e
	ld	(hl),a
	inc	h
	ld	a,(hl)
	or	d
	ld	(hl),a
;-------mistery hole: right half--------------------------------
	inc l
	ld	de,%1100000011111000
	ld	a,(hl)
	or	d
	ld	(hl),a
	dec	h
	ld	a,(hl)
	or	l
	ld	(hl),a
	dec	h
	ld	a,(hl)
	or	e
	ld	(hl),a
	dec	h
	or	c
	ld	(hl),a
	dec	h
	ld	(hl),a
	dec	h
	ld	a,(hl)
	or	e
	ld	(hl),a
	dec	h
	ld	a,(hl)
	or	l
	ld	(hl),a
	dec	h
	ld	a,(hl)
	or	d
	ld	(hl),a

;!!!----HOLE 17 banner-----------------------------------
	ld	hl,#4747

ramka:	EQU	#585a
atsprt:	EQU	#405a

	ld	(ramka),hl
	ld	(ramka+2),hl

	ld	hl,#FFFF
	ld	(atsprt),hl
	ld	(atsprt+2),hl
	ld	(atsprt+#700),hl
	ld	(atsprt+#700+2),hl

 	ld	hl,#2FB4
	ld	(atsprt+#100),hl

	ld	h,#21
	ld	(atsprt+#600),hl

	ld	hl,#D10F
	ld	(atsprt+#100+2),hl

	ld	hl,#AFB5
	ld	(atsprt+#200),hl
	ld	(atsprt+#400),hl
	ld	(atsprt+#500),hl

	ld	l,#85
	ld	(atsprt+#300),hl

	ld	hl,#DD7F
	ld	(atsprt+#200+2),hl
	ld	(atsprt+#400+2),hl
	ld	(atsprt+#500+2),hl

	ld	l,#0F
	ld	(atsprt+#300+2),hl
	ld	(atsprt+#600+2),hl

;-------shift CALL----------------------------------------------
	ld	hl,(spoint+1)
	ld	bc,fx_shift
	or	a		;clear carry flag
	sbc	hl, bc
;-------select CALL for new frame-------------------------------
	ld	e,(hl)
	inc	hl
	ld	d,(hl)	
	ex	de,hl

	dec	hl
	dec	hl
	dec	hl

;-------shift SP------------------------------------------------
	ld	a,(spoint+1)
	xor	#ff
	ld	(spoint+1),a

	ld	a,(spoint+2)
	xor	#0f
	ld	(spoint+2),a

	jp	im2exit

;!!!	PART 3: HOLE 11                                 

part3:
	ld	sp,0
	ld	hl,im2h11	;set JP to IM2 handler
	ld	(#fdfe),hl

	call	totalcls

	ld	a,7
	out	(#fe),a

	ld	a,#38
	call    attr

;-------HOLE 11----------------------
	ld	bc,0

	ld	de,4*21
	ld	l,e
slop2:
	add	hl,de
	
	ld	a,h
	cp	high begin
	jr	nc,slop2

slop3:	inc	(hl)

	ld	a,#47		;ATTR fix for BANNER
	ld	(ramka+2),a     ;
;!!!
	ld	a,#FF
	ld	(atsprt+2),a
	ld	(atsprt+2+#700),a
;	ld	a,#0F
;	ld	(atsprt+2+#100),a	
;	ld	(atsprt+2+#300),a
;	ld	(atsprt+2+#600),a
;	ld	a,#7F
;	ld	(atsprt+2+#200),a
;	ld	(atsprt+2+#400),a
;	ld	(atsprt+2+#500),a
;!!!
	inc	bc
	ld	a,b
	cp	52	;!! FX visual (delay befor INC/DEC swap)
	jp	nz,slop2

	ld	b,#01

	ld	a,(slop3)
	xor	b
	ld	(slop3),a

;---------------------------------------------------------------
	jr	slop2

;!! hole11 lenght

;-------end of HOLE 11----------------------
im2h11:
	push	af
	push	hl
	push	de
	push	bc

;!!!-------HOLE11 banner-----------------------------------

	ld	hl,#4747	;color

	ld	(ramka),hl
	ld	(ramka+2),hl

	ld	hl,#FFFF
	ld	(atsprt),hl
	ld	(atsprt+2),hl
	ld	(atsprt+#700),hl
	ld	(atsprt+#700+2),hl

	ld	hl,#2FB4
	ld	(atsprt+#100),hl

	ld	h,#21
	ld	(atsprt+#600),hl

	ld	hl,#DD0F
	ld	(atsprt+#100+2),hl
	ld	(atsprt+#300+2),hl
	ld	(atsprt+#600+2),hl

	ld	l,#7F
	ld	(atsprt+#500+2),hl
	ld	(atsprt+#200+2),hl
	ld	(atsprt+#400+2),hl

	ld	hl,#AFB5
	ld	(atsprt+#200),hl
	ld	(atsprt+#400),hl
	ld	(atsprt+#500),hl

	ld	l,#85
	ld	(atsprt+#300),hl

;---------------------------------------------------------------
	call	play

	ld	hl,(frames)
	inc	hl
	ld	(frames),hl

	ld	de,sync11	;hole 11 lenght
	or	a
	sbc	hl,de
	add	hl,de
	jp	nz,next11

	pop	bc
	pop	de
	pop	hl
	pop	af

	jp	ret11

;---------------------------------------------------------------
next11:
	ld	bc,#7ffe
	in	a,(c)
	rrca
	jr	nc,$-6

	pop	bc
	pop	de
	pop	hl
	pop	af
	ei
	ret

;-------delay-----------------------------
delay:
	ld	b,pause
outer:	ld	d,b
inner:	dec	de	
	ld	a,d
	or	e
	jr	nz,inner
	djnz	outer
	ret
im2ay:
	push	af
	push	hl
	push	de
	push	bc
	exx
	push	hl
	push	de
	push	bc

	call	play

	ld	hl,(frames)
	inc	hl
	ld	(frames),hl

	ld	bc,#7ffe
	in	a,(c)
	rrca
	jr	nc,$-3

	pop	bc
	pop	de
	pop	hl
	exx
	pop	bc
	pop	de
	pop	hl
	pop	af
	ei
	ret

;!!! if 1=2
;-------pixel cls-------------------------------------------
;pixcls:
;	ld	(savesp+1),sp
;	ld	sp,#5800
;	ld	b,0
;	ld	h,a
;	ld	l,a

;	DUP	12
;	push	hl
;	EDUP

;	djnz	$-12

;savesp:	ld	sp,#3131	;0
;	ret

;---------------------------------------------------------------
; endif

clr_scr:
	call	halt_atr_push_border_0

scrcls_0:
	xor	a
pixcls:
scrcls_a:
	ld	b,#c0
	ld	hl,#5800
	jr	atrpush_scr

halt_atr_push_border_0:
	xor	a

attrcls:
halt_atr_push_border_a:
	ei
	halt
	ld	(attr-1),a
	and	%00000111
	out	(#fe),a
	ld	a,0
attr:
atrpush_a:
	ld	b,#18
	ld	hl,#5b00

atrpush_scr:

	LD	(sp_atr1),SP
 ld sp,hl
	LD	H,A
	LD	L,H
attrloop:
 dup #10
	PUSH	HL
 edup
	DJNZ	attrloop

	LD	SP,#0000
sp_atr1 equ $-2
	RET

;!! if 1=2
;attrcls:
;	ei
;	halt
;	ld	(attr-1),a
;	and	%00000111
;	out	(#fe),a
;	ld	a,0
;attr:	ld	(attrsp+1),sp
;	ld	sp,#5b00
;	ld	h,a
;	ld	l,h
;	ld	b,768/2/4
;attrloop:
;	DUP	4
;	push	hl
;	EDUP
;	djnz	attrloop
;attrsp:	ld	sp,#3131	;0
;	ret
; endif

starloop_to_de:
	ld	a,#21
	jr	$+4

starloop_to_de_atr:
	ld	a,#cd

	ld	(atrstar),a

starloop_lp:
	push	de

	halt
	call	pts_cls

	call	starser

	pop	de
	LD	HL,(frames)
	OR	A
	SBC	HL,DE
	jr	c,starloop_lp

	ret

starser:
	call	prnd
	and	#07
	jr	nz,$+4
	ld	a,#02
	or	#40

atrstar	ld	hl,atrpush_a	;[ld hl,..] / [call ..]


	ld	h,SIN_TBL/256

 ld a,r
 and #03
 inc a
 ld c,a

	ld	a,#00
a_str1 equ $-1

	add	a,c
	ld	(a_str1),a

	ld	l,a
	ld	b,(hl) 

 ld a,r
 and #01
 inc a
 ld c,a

	ld	a,#20
a_str2 equ $-1

	add 	a,c
	ld	(a_str2),a

	ld	l,a
	ld	c,(hl)

	ld	a,#00
a_str3 equ $-1
	inc	a
        LD      (a_str3),a

	ld	l,a
	ld	l,(hl)
	ld	h,#12
	add	hl,hl

	ld	(0),sp
sp_strw equ $-2

	ld	sp,hl
	jp	pts_out
BL1:
	pop	hl
	add	hl,bc
	ld	a,h

	ld	h,SMULTBL/256
ch_bl1 equ $-1

	ld	e,(hl) 
	ld	l,a
	ld	l,(hl) 
	ld	h,SCR_TBL/256
	ld	a,(hl) 
	inc	h 
	ld	d,(hl) 
	inc	h		;BUFFER1
	ld	l,e 
	add	a,(hl) 
	ld	e,a
	inc	h
	ld	a,(de)

	ld	(0),a
pts_byte equ $-2

	or	(hl) 
	ld	(de),a

	ld	(0),de
pts_adr equ $-2

LN1 equ $-BL1

DATAEND EQU     PTS_NUM*LN1+4+pts_out
 if DATAEND>begin
  display "!!! ERROR: DATAEND !!!"
 endif

wait_to_de:
	LD	HL,(frames)
	OR	A
	SBC	HL,DE
	jr	c,wait_to_de
	RET

printer_with_stars:
	LD	A,(HL)
	OR	A
	RET	Z

	INC	HL
	PUSH	HL
	PUSH	DE

 push af
	halt
	call	pts_cls
	call	starser
	halt
	call	pts_cls
 pop af
 pop de
 pop hl
 push hl
 push de
	CALL	prnchar
	call	starser

	POP	DE
	POP	HL
	INC	E
	BIT	5,E
	JR	Z,L_F225_

	INC	D
;	LD	E,B
 ld e,#00

L_F225_:
	JR	printer_with_stars

 ifdef __RNDSTARS
rnd_stars:
	ld	b,#18

lp_str_:
	push	bc
	ld	b,#20
	halt
	djnz	$-1

lp_str0:
	call	prnd
 and #1f
 cp #18
 jr c,$+4
 sub #10

 or #40
 ld h,a

 call prnd
	ld	l,a

	call	prnd
	and	#07
	ld	b,a
	ld	a,#80
	jr	z,go_str0

	rrca
	djnz	$-1
go_str0
	or	(hl)
	ld	(hl),a

	pop	bc
	djnz	lp_str_

	ret
 endif ;/__RNDSTARS

 align #0100

SIN_TBL	ds	#0100

inistar:
	ld	de,#4000

;	ld	hl,SCR_TBL
;	ld	(hl),e
;	inc	l
;	jr	nz,$-2

;	inc	h
 ld hl,SCR_TBL+#0100
	ld	(hl),e
	inc	l
	jr	nz,$-2

;	ld	hl,SCR_TBL+#0120
 ld l,#20
	ld	b,#c0

lp_ini1:
	dec	h
	ld	(hl),e
	inc	h
	ld	(hl),d
	inc	l

	inc	d
	ld	a,d
	and	#07
	jr	nz,godownde

	ld	a,e
	sub	#e0
	ld	e,a
	sbc	a,a
	and	#f8
	add	a,d
	ld	d,a

godownde:
        djnz    lp_ini1


	ld	hl,BUFFER1

lp_ini2:
	ld	a,l
	rra
	rra
	rra
	and	#1f
	ld	(hl),a
	inc	l
	jr	nz,lp_ini2

	inc	h

	ld	a,#80
ch_plashki equ $-1


lp_ini3:
	ld	(hl),a
	rrca
	inc	l
	jr	nz,lp_ini3


	ld	hl,SMULTBL
	ld	de,-SCL_ST
	ld	b,SMULSIZE

lp_ini4:
	push	bc
	push	hl 

	ex	de,hl
	ld	bc,-SCL_ADD
	add	hl,bc
	ex	de,hl

	ld	hl,ST_MAX

;	ld	c,#ff
 ld c,h

lp_ini5:
	inc	c
	add	hl,de
	jr	c,lp_ini5

	pop	hl

lp_ini6:
	push	hl

	ld	a,l
	add	h		;+
	add	a,#80

;IMUL_AC:
	ld	h,a
	xor	c
	push	af

	xor	a
	ld	b,a
	ld	l,a

	sub	c
	jp	m,$+4
	ld	c,a

	xor	a
	sub	h
	jp	m,$+4
	ld	h,a

 dup 8
	add	hl,hl
	jr	nc,$+3
	add	hl,bc
 edup

	add	hl,hl

	pop	af
	ld	a,h
;	ret	p
 jp p,$+5

	neg

;	ld	h,a
;	ret
;/IMUL_AC

	pop	hl
	add	a,#80
	ld	(hl),a
	inc	l
	jr	nz,lp_ini6

	inc	h

	pop	bc
	djnz	lp_ini4



	ld	hl,PTS_NUM*5+pts_cls
	ld	(hl),#c9    ;ret

	ld	de,pts_out
	ld	b,PTS_NUM

lp_ini7:
	push	bc

	ld	a,SMULSIZE-1
	and	b
	add	a,SMULTBL/256
	ld	(ch_bl1),a

	xor	a
	dec	hl
	ld	(hl),a
	dec	hl
	ld	(hl),a
 ld (pts_adr),hl
	dec	hl
	ld	(hl),#32	;[ld (...),a]
	dec	hl
	ld	(hl),a
 ld (pts_byte),hl
	dec	hl

	ld	(hl),0
		org $-1
		ld a,0
		org $-1

	push	hl
	ld	hl,BL1
	ld	bc,LN1
	ldir
	pop	hl

	pop	bc
	djnz	lp_ini7

	ex	de,hl
	ld	(hl),0
		org $-1
		ld sp,0
		org $-2
	inc	hl
	ld	(sp_strw),hl
	inc	hl
	inc	hl
	ld	(hl),#c9	;ret

	ret
;/inistar

;---------------------------------------------------------------
mainfx:
	ld	bc,#7ffe
	in	a,(c)
	rrca
	jr	nc,$-3
	ret

;---------------------------------------------------------------
rndfill:
;	H = last segment for pRNG data
rndlop:
	call	prnd
;	call	xorsh

	ld	(hl),a
	dec	hl
	ld	a,h
	cp      #5a		;end of RAM check
	jr	nz,rndlop
	ret

;!!-----MUSIC, aligned AY player and font----
music:
	INCBIN	"music.mus"

	INCLUDE "l4_psg_player.asm"

	align	256
font:	
	INCBIN	"font.bin",0,768-48

;!! INTRO management code--------------

;-------comeback from HOLE NEW-------------------------
retnew:
	ld	sp,0
	ld	hl,im2ay
	ld	(#fdfe),hl      ;set JP to IM2 handler

	call	totalcls

slide6:	;FINAL RMDA
	ld	a,04q
	call	attr

	ld	hl,#5960
	ld	de,#5961
	ld	bc,32*7
	ld	(hl),104q
	ldir

	ld	de,#0900	;D=Y, E=X
	ld	hl,text6
	call	string

;	ld	b,#10
;	call	delay+2

;!!!!print with stars  

 ld a,#aa
 ld (ch_plashki),a
 call inistar

 ld a,#cd
 ld (atrstar),a

	ld	de,#0900	;D=Y, E=X
	ld	hl,text6
 call printer_with_stars

 ld de,syncend
 call starloop_to_de_atr

	call	stop

	ld	hl,im2ret
	ld	(#fdfe),hl      ;set JP to IM2 handler

        call 	totalcls

	call	slide7

	ld	b,#25
	call	delay+2

;	call	nanohl
	call	nanohl

	ld	hl,im2fin
	ld	(#fdfe),hl      ;set JP to IM2 handler

;!!                                                             
finalcut:

color1:	equ	05q

;-------memory and screen init----------------------------------
	ld	hl,finalcut
	push	hl

clear1:	ld	(hl),0
	dec	hl
	ld	a,h
	cp	#5a	
	jr	nz,clear1
;---------------------------------------------------------------
	pop	hl
	ld	bc,1		;counter of generated calls
	ld	ix,#0000	;counter of full loops
;---------------------------------------------------------------
				;HL - current address for CALL
				;DE - destination for CALL
				;BC - counter generated of CALLs
newrnd1:
	ld	(hl),#cd	;new address, lets put #CD/CALL
	inc	hl		; 
	inc	hl              ;with anything, but not #00
	ld	(hl),h          ;coz #00 is the mark of free RAM
	dec	hl		;for CALL generator
;---------------------------------------------------------------
rernd1:
	call	prnd		;get pRNG for high byte of DE
;	call	rnd		;get pRNG for high byte of DE

	cp	#5b		;must be more than #5a
	jr	nc,next1
	jr	rernd1
next1:	
	ld	d,a		;store pRNG high byte in D
;---------------------------------------------------------------
	call	prnd		;get pRNG for low byte
;	call	rnd		;get pRNG for low byte

	ld	e,a		;any pRNG is valid so store it E
;---------------------------------------------------------------
;in HL adress of LOW byte for new CALL
;in DE destination adress of new CALL
	ld	a,(de)          
	or	a               ;check is there 0 in RAM for #CD
	jp	nz,rernd1	;if not 0 then redo pRNG
;---------------------------------------------------------------
	inc	de
	ld	a,(de)
	or	a
	jp	nz,rernd1	;is there 0 in RAM for low byte?
;---------------------------------------------------------------
	inc	de
	ld	a,(de)		
	or	a
	jp	nz,rernd1        ;is there 0 for high byte?
;---------------------------------------------------------------
	dec	de
	dec	de

	ld	(hl),e		;put argument (new PC address) 
	inc	hl		;for #CD, chosen in nextrnd.
	ld	(hl),d       

	ld	h,d		;set this new adress as next 
	ld	l,e		;VALID address for #CD or any 
				;other 1-2-3 bytes oppcode.
			
	inc	bc

	ld	a,b

	cp	#2c		;!!complexity, check amount of generated CALLs

	jp	nz,newrnd1
;---------------------------------------------------------------
	ld	de,looper1	;patch for end sequence of CALL's
	ld	(hl),#c3	;put JP at the end
	inc	hl		;to loop generated data.
	ld	(hl),e
	inc	hl          
	ld	(hl),d		;generated code is looped now.
;---------------------------------------------------------------

	halt                    ;very important to remove yellow

	ld	hl,#5800
	ld	de,#5801
	ld	bc,767
	ld	(hl),color1
	ldir
debug:
;---------------------------------------------------------------
	ld	hl,int1
	ld	(#fdfe),hl
;-------AY-FX-------------------------------------------------
	ld	hl,im2exit1+9
	ld	e,#0d
ayl:	ld	bc,#fffd
	out	(c),e
	ld	b,#bf
	outi
	dec	e
	jr	nz,ayl
;---------------------------------------------------------------
	ld	hl,finalcut	;START of CALL sequence

;-------first run + end part of IM2 handler---------------------
im2exit1:
	ei
spoint1:
	ld	sp,#5800
	jp	(hl)
looper1:
	jp	finalcut

;---------------------------------------------------------------
int1:
	ld	a,color1
	out	(#fe),a
	inc	ixh
	jr	nz,leave

        ld      ix,0
	ld	hl,(sdvig+1)
	inc	hl
	inc	hl
	ld	(sdvig+1),hl
leave:
;-------keyboard------------------------------------------------
enigma1:	
	ld	hl,color1 * #101
       	ld	(dedatr),hl
	ld	(dedatr+2),hl

	ld	(leaxatr),hl
	ld	(leaxatr+2),hl

	ld	(srzatr),hl
	ld	(srzatr+2),hl

	ld	(krugatr),hl
	ld	(krugatr+2),hl

	ld	bc,#7ffe
	in	a,(c)
	rrca
	jr	nc,enigma1	;SPACE to solve enigma.

;-------serzh blink---------------------------------------------
	ld	a,#07		;#07;#4f;#0f;#47
a_hl1:	equ $-1
	xor 0+(#07 xor #05)
	ld (a_hl1),a
	ld l,a
	ld h,a

;-------final sprites-------------------------------------------
dedspr:		EQU	#40e3
dedatr:		EQU	dedspr+6144
leaxspr:	EQU	#4000+#e0+4+4+4-2
leaxatr:	EQU	leaxspr+6144
srzspr:		EQU	#4000+#e0+4+4+4+4+4+4+4-3
srzatr:		EQU	srzspr+6144
krugspr:	EQU	#4000+#e0+4+4+4+4+4-2
krugatr:	EQU	krugspr+6144

       	ld	(dedatr),hl
	ld	(dedatr+2),hl

       	ld	(leaxatr),hl
	ld	(leaxatr+2),hl

       	ld	(srzatr),hl
	ld	(srzatr+2),hl

       	ld	(krugatr),hl
	ld	(krugatr+2),hl

	ld	hl,#FFFF
	ld	(dedspr),hl
	ld	(dedspr+2),hl
	ld	(dedspr+#700),hl
	ld	(dedspr+#700+2),hl
	ld	(dedspr+#100+2),hl

	ld	(leaxspr),hl
	ld	(leaxspr+2),hl
	ld	(leaxspr+#700),hl
	ld	(leaxspr+#700+2),hl

	ld	(srzspr),hl
	ld	(srzspr+2),hl
	ld	(srzspr+#700),hl
	ld	(srzspr+#700+2),hl
	ld	(srzspr+#100+2),hl

	ld	(krugspr),hl
	ld	(krugspr+2),hl
	ld	(krugspr+#700),hl
	ld	(krugspr+#100+2),hl

;	ld	hl,#FFE7          
	ld	l,#E7
	ld	(dedspr+#100),hl
	ld	(srzspr+#100),hl

	ld	h,#C3
;	ld	hl,#C3E7     
	ld	(dedspr+#200),hl

	ld	l,h
;	ld	hl,#C3C3
	ld	(srzspr+#200),hl
;	ld	hl,#C3F9	
	ld	l,#F9
	ld	(dedspr+#300+2),hl
;	ld	hl,#C399     
	ld	l,#99
	ld	(dedspr+#500+2),hl
;	ld	hl,#C3C0    
	ld	l,#C0
	ld	(srzspr+#400),hl

;	ld	hl,#C3FF     
	ld	l,#ff
	ld	(krugspr+#700+2),hl

	ld	hl,#99C3 
	ld	(dedspr+#200+2),hl

;	ld	hl,#F9C3
	ld	h,#F9
	ld	(leaxspr+#200+2),hl
	ld	(krugspr+#600+2),hl
;	ld	hl,#E1C3
	ld	h,#E1
	ld	(krugspr+#200),hl

;	ld	hl,#CFC3
	ld	h,#CF
	ld	(krugspr+#500),hl

;	ld	hl,#CFC9   
	ld	l,#C9
	ld	(krugspr+#600),hl

;	ld	hl,#CFC7     
	ld	l,#C7
	ld	(krugspr+#400),hl

;	ld	hl,#CFCF    
	ld	l,h
	ld	(srzspr+#500+2),hl

;	ld	hl,#F3CF
	ld	h,#F3
	ld	(srzspr+#300+2),hl    

;	ld	hl,#E7CF
	ld	h,#E7
	ld	(srzspr+#400+2),hl

;	ld	hl,#FFCF     
	ld	h,#FF
	ld	(krugspr+#100),hl

	ld	hl,#C1FF 
	ld	(leaxspr+#300),hl

;	ld	hl,#C199 
	ld	l,#99
	ld	(leaxspr+#300+2),hl

;	ld	hl,#C1F1 
	ld	l,#F1
	ld	(dedspr+#600),hl

;	ld	hl,#C1E3 
	ld	l,#E3
	ld	(leaxspr+#600),hl

;	ld	hl,#C1C1
	ld	l,h
	ld	(leaxspr+#600+2),hl

;	ld	hl,#C199
	ld	l,#99
	ld	(krugspr+#200+2),hl
	ld	(krugspr+#500+2),hl

;	ld	hl,#F999
	ld	h,#F9
	ld	(srzspr+#500),hl

;	ld	hl,#9999     
	ld	h,l
	ld	(krugspr+#300+2),hl
	ld	(krugspr+#400+2),hl

;	ld	hl,#99E7
	ld	l,#E7
	ld	(dedspr+#300),hl

;	ld	hl,#99C1     
	ld	l,#C1
	ld	(dedspr+#600+2),hl

;	ld	hl,#99FF 
	ld	l,#FF
	ld	(leaxspr+#400),hl

;	ld	hl,#9983 
	ld	l,#83
	ld	(leaxspr+#400+2),hl

;	ld	hl,#99E3 
	ld	l,#E3
	ld	(leaxspr+#500),hl
;	ld	hl,#999F 
	ld	l,#9F
	ld	(leaxspr+#500+2),hl

	ld	hl,#83E7 
	ld	(dedspr+#400),hl

;	ld	hl,#9FE7     
	ld	h,#9F
	ld	(dedspr+#500),hl
	ld	(srzspr+#300),hl


	ld	hl,#E7C1     
	ld	(dedspr+#400+2),hl

	ld	hl,#F9FF          
	ld	(leaxspr+#100),hl
	ld	(leaxspr+#100+2),hl
	ld	(leaxspr+#200),hl

	ld	hl,#81E1
	ld	(srzspr+#200+2),hl

;	ld	hl,#81CF    
	ld	l,#CF
	ld	(srzspr+#600+2),hl
	ld	hl,#83C0    
	ld	(srzspr+#600),hl

	ld	hl,#CFC7     
	ld	(krugspr+#300),hl

;!! nano HOLE
;!! CPL may be removed
nanoat1:	EQU	#44e0-#4b-#1a-4-#100

	ld	a,(nanoat1)
	or	#18	;#e7
	cpl
	ld	(nanoat1),a

	ld	a,(nanoat1+#200)
	or	#18	;#e7
	cpl
	ld	(nanoat1+#200),a

	ld	a,(nanoat1+#100)	
	or	#7e
	cpl
	ld	(nanoat1+#100),a

;-------shift CALL----------------------------------------------
	ld	hl,(spoint1+1)
sdvig:	ld	bc,2		;fx_shift
	or	a		;clear carry flag
	sbc	hl, bc
;-------select CALL for new frame-------------------------------
	ld	e,(hl)
	inc	hl
	ld	d,(hl)	
	ex	de,hl

	dec	hl
	dec	hl
	dec	hl

;-------shift SP------------------------------------------------
	ld	a,(spoint1+1)	;!!!
	xor	#ff		;!!! low SP shift #5800 <> #57ff
	ld	(spoint1+1),a	;!!!

	ld	a,(spoint1+2)	;!!!
	xor	#0f		;!!! high SP shift
	ld	(spoint1+2),a	;!!!

	jp	im2exit1

;-------IM2 handler-----------------------
	org	#fdfd
	jp	#fdfd		;will be updated at start

;-------IM2 table-------------------------
	DUP	#101
	defb	#fd	;IM2 table area #FE00-FF00 = #FD
	EDUP

frames:	defb	#fd,#fd

table:
	DUP	10
	defb	#fd
	EDUP

;---------------------------------------------------------------
;Fast quality CMWC random number generator by Patrik Rak
;---------------------------------------------------------------
prnd:
	exx

	ld   hl,table

        ld   a,(hl) ; i = ( i & 7 ) + 1
        and  7
        inc  a
        ld   (hl),a

        inc  l      ; hl = &cy

        ld   d,h    ; de = &q[i]
        add  a,l
        ld   e,a

        ld   a,(de) ; y = q[i]
        ld   b,a
        ld   c,a
        ld   a,(hl) ; ba = 256 * y + cy

        sub  c      ; ba = 255 * y + cy
        jr   nc,$+3
        dec  b

        sub  c      ; ba = 254 * y + cy
        jr   nc,$+3
        dec  b

        sub  c      ; ba = 253 * y + cy
        jr   nc,$+3
        dec  b

        ld   (hl),b ; cy = ba >> 8, x = ba & 255
        cpl         ; x = (b-1) - x = -x - 1 = ~x + 1 - 1 = ~x
        ld   (de),a ; q[i] = x

	exx
        ret
;---------------------------------------------------------------
;8-bit Xor-Shift random number generator by Patrik Rak
;---------------------------------------------------------------
;xorsh:	
;	exx
;	ld  hl,0xA280   ; yw -> zt
;	ld  de,0xC0DE   ; xz -> yw
;	ld  (xorsh+5),hl  ; x = y, z = w
;	ld  a,l         ; w = w ^ ( w << 3 )
;	add a,a
;	add a,a
;	add a,a
;	xor l
;	ld  l,a
;	ld  a,d         ; t = x ^ (x << 1)
;	add a,a
;	xor d
;	ld  h,a
;	rra             ; t = t ^ (t >> 1) ^ w
;	xor h
;	xor l
;	ld  h,e         ; y = z
;	ld  l,a         ; w = t
;	ld  (xorsh+2),hl
;	exx
;	ret 
;---------------------------------------------------------------

im2fin:
	push	af
	push	bc

	ld	bc,#7ffe
	in	a,(c)
	rrca
	jr	nc,$-3		;SPACE to solve enigma

	ld	a,(#587b)
	inc	a
	and	%00000111
	ld	(#587b),a	;nanohole decrunch

	pop	bc
	pop	af
im2ret:	ei
	ret

;---------------------------------------------------------------
totalcls:
	xor	a
	call	attrcls
	call	pixcls
	ret
;---------------------------------------------------------------
nanohl:
	ld	b,#5b*2
	
nanoat:	EQU	#44e0-#4b-#1a

	ld	a,#18
	ld	(nanoat),a
	ld	(nanoat+#200),a
	ld	a,#7e
	ld	(nanoat+#100),a

	ld	a,%01000111
flash:	
	ld	(#587b),a
	xor	7
	ei
	halt
	djnz	flash
	ret

fin:

;!! simple BASIC creator for .TAP

;ZXB_CLEAR	EQU     $FD
;ZXB_VAL		EQU     $B0
;ZXB_OUT		EQU     $DF
;ZXB_POKE	EQU     $F4
;ZXB_LOAD	EQU     $EF
;ZXB_CODE	EQU     $AF
;ZXB_RANDOMIZE	EQU     $F9
;ZXB_USR		EQU     $C0

;	ORG #0000

;BASIC_START  
;	db 0,0
;	dw LINE_LEN
;BASIC_LINE  db ZXB_CLEAR,ZXB_VAL,'"32768":'
;	db ZXB_LOAD,'"0001"',ZXB_CODE,':'
;	db ZXB_RANDOMIZE,ZXB_USR,ZXB_VAL,'"32768"'
;	db 13
;BASIC_END
;LINE_LEN	EQU  BASIC_END-BASIC_LINE
;BASIC_LEN	EQU  BASIC_END-BASIC_START
	
;	EMPTYTAP "intro.tap"
;	SAVETAP  "intro.tap",BASIC,"0001",BASIC_START,BASIC_LEN,0
;	SAVETAP	"intro.tap",CODE,"0001",begin,fin-begin

;---------------------------------------------------------------
;	SAVESNA	"intro.sna", begin
	SAVEBIN	"intro.bin", begin,fin-begin

;-------=RMDA=---------------------------------------------[eof]